
/********************************** (C) COPYRIGHT *********************************
* File Name          : Moduleconfig.H
* Description        :λͨݽṹ
*                      
**********************************************************************************/
#ifndef __MODULECONFIG_H__
#define __MODULECONFIG_H__

#include "debug.h"

/*洢Ϣĵַ*/
#define PAGE_WRITE_START_ADDR     ((uint32_t)0x0803FF00) /* Start from (256K - 256B) */
#define PAGE_WRITE_END_ADDR       ((uint32_t)0x08040000) /* End at 256K */
#define FLASH_PAGE_SIZE           256

#define NET_MODULE_DATA_LENGTH    60                     //ģͨʱ󳤶
#define MODULE_CFG_LEN            44                     //buff
                                                                                      
//ͨ                                                                          
#define NET_MODULE_CMD_SET        0X01                   //еģ
#define NET_MODULE_CMD_GET        0X02                   //ȡĳģ
#define NET_MODULE_CMD_RESET      0X03                   //ȡĳģ
#define NET_MODULE_CMD_SEARCH     0X04                   //еģ
                                                                                      
//Ӧ                                                                          
#define NET_MODULE_ACK_SET        0X81                   //Ӧ
#define NET_MODULE_ACK_GET        0X82                   //Ӧȡ
#define NET_MODULE_ACK_RESET      0X83                   //ȡĳģ
#define NET_MODULE_ACK_SEARCH     0X84                   //Ӧ
                                                                                      
#define NET_MODULE_FLAG           "WCHNET_MODULE"        //ʶλͨ
#define checkcode1                0X11                   //ʶϢ
#define checkcode2                0x22

//ͨŽṹ
typedef struct NET_COMM {
  unsigned char flag[16];                                //ͨűʶΪù㲥ʽͨŵģһ̶ֵ
  unsigned char cmd;                                     //ͷ
  unsigned char id[6];                                   //ʶCH563MACַ
  unsigned char len;                                     //
  unsigned char dat[NET_MODULE_DATA_LENGTH];             //
}net_comm,*pnet_comm;

//ģʶ
#define  NET_MODULE_TYPE_TCP_S    0X00                   //ģΪTCP SERVER
#define  NET_MODULE_TYPE_TCP_C    0X01                   //ģΪTCP CLIENT
#define  NET_MODULE_TYPE_UDP_S    0X02                   //ģΪUDP SERVER
#define  NET_MODULE_TYPE_UDP_C    0X03                   //ģΪUDP CLIENT
#define  NET_MODULE_TYPE_NONE     0X04                   //ģĬãκģʽ

//ģýṹ
typedef struct MODULE_CFG {
  unsigned char module_name[21];                         //ģ鱾IPַ
  unsigned char type;                                    //ʶģ鴦ģʽ(TCP/UDP server/client)
  unsigned char src_ip[4];                               //ģ鱾IPַ
  unsigned char mask[4];                                 //ģ鱾
  unsigned char getway[4];                               //ģӦصַ
  unsigned char src_port[2];                             //ģԴ˿
  unsigned char dest_ip[4];                              //ĿIPַ
  unsigned char dest_port[2];                            //ĿĶ˿
  unsigned char cfg_flag[2];                             //ڶȡEEEPROMʱ֤Ϣ
}module_cfg,*pmodule_cfg;

extern u8 MACAddr[6];
extern u8 Configbuf[MODULE_CFG_LEN];
extern u8  brocastIp[4];                                 /*㲥IPַɸ*/
extern u16 brocastPort;                                  /*λͨѶ˿ں*/

/*erase Data-Flash block, minimal block is 256B, return SUCCESS if success*/
extern void EEPROM_ERASE(uint32_t Page_Address, u32 Length );

/*write Data-Flash data block, return FLASH_Status*/
extern FLASH_Status EEPROM_WRITE( u32 StartAddr, u8 *Buffer, u32 Length );

/*read Data-Flash data block */
extern void EEPROM_READ( u32 StartAddr, u8 *Buffer, u32 Length );

extern u8 Default_cfg[MODULE_CFG_LEN];
extern pmodule_cfg CFG;
extern u8 ParseConfigbuf(u8 *buf);
#endif
