/********************************** (C) COPYRIGHT *******************************
* File Name          : ch32v30x_usbhs_device.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2021/06/06
* Description        : USBٲļ
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* SPDX-License-Identifier: Apache-2.0
*******************************************************************************/
#include "ch32v30x_usbhs_device.h"

/******************************************************************************/
/*  */

/*  */
void USBHS_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

/* USB */
__attribute__ ((aligned(4))) UINT8 EP0_Databuf[ DEF_USBD_UEP0_SIZE ]; /* ˵0շ */
__attribute__ ((aligned(4))) UINT8 EP1_Rx_Databuf[ DEF_USBD_MAX_PACK_SIZE ]; /* ˵1ݽջ */
__attribute__ ((aligned(4))) UINT8 EP1_Tx_Databuf[ DEF_USBD_MAX_PACK_SIZE ]; /* ˵1ݷͻ */
__attribute__ ((aligned(4))) UINT8 EP2_Rx_Databuf[ DEF_USBD_MAX_PACK_SIZE ]; /* ˵2ݽջ */
__attribute__ ((aligned(4))) UINT8 EP2_Tx_Databuf[ DEF_USBD_MAX_PACK_SIZE ]; /* ˵2ݷͻ */

#define pMySetupReqPak        ((PUSB_SETUP_REQ)EP0_Databuf)
#if DEF_USBD_SPEED == DEF_USBD_SPEED_LOW
#define RepDataLoadLen        8
#else
#define RepDataLoadLen        64
#endif
const UINT8 *pDescr;
volatile UINT8  USBHS_Dev_SetupReqCode = 0xFF;                                  /* USB2.0豸Setup */
volatile UINT16 USBHS_Dev_SetupReqLen = 0x00;                                   /* USB2.0豸Setup */
volatile UINT8  USBHS_Dev_SetupReqValueH = 0x00;                                /* USB2.0豸SetupValueֽ */
volatile UINT8  USBHS_Dev_Config = 0x00;                                        /* USB2.0豸ֵ */
volatile UINT8  USBHS_Dev_Address = 0x00;                                       /* USB2.0豸ֵַ */
volatile UINT8  USBHS_Dev_SleepStatus = 0x00;                                   /* USB2.0豸˯״̬ */
volatile UINT8  USBHS_Dev_EnumStatus = 0x00;                                    /* USB2.0豸ö״̬ */
volatile UINT8  USBHS_Dev_Endp0_Tog = 0x01;                                     /* USB2.0豸˵0ͬ־ */
volatile UINT8  USBHS_Dev_Speed = 0x01;                                         /* USB2.0豸ٶ */
volatile UINT8  USBHS_Int_Flag  = 0x00;                                         /* USB2.0豸жϱ־ */

volatile UINT16 USBHS_Endp1_Up_Flag = 0x00;                                     /* USB2.0豸˵1ϴ״̬: 0:; 1:ϴ; */
volatile UINT8  USBHS_Endp1_Down_Flag = 0x00;                                   /* USB2.0豸˵1´ɹ־ */
volatile UINT8  USBHS_Endp1_Down_Len = 0x00;                                    /* USB2.0豸˵1´ */
volatile UINT8  USBHS_Endp1_T_Tog = 0x00;
volatile UINT8  USBHS_Endp1_R_Tog = 0x00;

volatile UINT16 USBHS_Endp2_Up_Flag = 0x00;                                     /* USB2.0豸˵2ϴ״̬: 0:; 1:ϴ; */
volatile UINT16 USBHS_Endp2_Up_LoadPtr = 0x00;                                  /* USB2.0豸˵2ϴװƫ */
volatile UINT8  USBHS_Endp2_Down_Flag = 0x00;                                   /* USB2.0豸˵2´ɹ־ */

/******************************************************************************/
/* USB豸 */
UINT8  MyDevDescr[ 18 ] =
{
    0x12, 0x01, 0x00, 0x02, 0x00, 0x00, 0x00, 0x40,
    0x86, 0x1A, 0x37, 0x55,
    DEF_IC_PRG_VER2, DEF_IC_PRG_VER, 0x01, 0x02, 0x00, 0x01
};

/* USB(ȫ) */
const UINT8  MyCfgDescr_FS[ ] =
{
    0x09, 0x02, 0x2E, 0x00, 0x01, 0x01, 0x00, 0x80, 0x32,
    0x09, 0x04, 0x00, 0x00, 0x04, 0xFF, 0xFF, 0xFF, 0x00,
    0x07, 0x05, 0x81, 0x02, (UINT8)DEF_USB_FS_EP_SIZE, (UINT8)( DEF_USB_FS_EP_SIZE >> 8 ), 0x00,
    0x07, 0x05, 0x01, 0x02, (UINT8)DEF_USB_FS_EP_SIZE, (UINT8)( DEF_USB_FS_EP_SIZE >> 8 ), 0x00,
    0x07, 0x05, 0x82, 0x02, (UINT8)DEF_USB_FS_EP_SIZE, (UINT8)( DEF_USB_FS_EP_SIZE >> 8 ), 0x00,
    0x07, 0x05, 0x02, 0x02, (UINT8)DEF_USB_FS_EP_SIZE, (UINT8)( DEF_USB_FS_EP_SIZE >> 8 ), 0x00,
};

/* USB() */
const UINT8  MyCfgDescr_HS[ ] =
{
    0x09, 0x02, 0x2E, 0x00, 0x01, 0x01, 0x00, 0x80, 0x32,
    0x09, 0x04, 0x00, 0x00, 0x04, 0xFF, 0xFF, 0xFF, 0x00,
    0x07, 0x05, 0x81, 0x02, (UINT8)DEF_USB_HS_EP_SIZE, (UINT8)( DEF_USB_HS_EP_SIZE >> 8 ), 0x00,
    0x07, 0x05, 0x01, 0x02, (UINT8)DEF_USB_HS_EP_SIZE, (UINT8)( DEF_USB_HS_EP_SIZE >> 8 ), 0x00,
    0x07, 0x05, 0x82, 0x02, (UINT8)DEF_USB_HS_EP_SIZE, (UINT8)( DEF_USB_HS_EP_SIZE >> 8 ), 0x00,
    0x07, 0x05, 0x02, 0x02, (UINT8)DEF_USB_HS_EP_SIZE, (UINT8)( DEF_USB_HS_EP_SIZE >> 8 ), 0x00,
};

/* USBַ */
const UINT8  MyLangDescr[ ] =
{
    0x04, 0x03, 0x09, 0x04
};

/* USBַ */
const UINT8  MyManuInfo[ ] =
{
    /* wch.cn */
    0x0E, 0x03,
    'w',0x00, 'c',0x00, 'h',0x00, '.',0x00, 'c',0x00, 'n',0x00
};

/* USBƷַ */
const UINT8  MyProdInfo[ ] =
{
    /* WCH USB2.0 DEVICE */
    0x26, 0x03,
    'W',0x00, 'C',0x00, 'H',0x00, ' ',0x00, 'U',0x00, 'S',0x00,
    'B',0x00, '2',0x00, '.',0x00, '0',0x00, ' ',0x00, 'D',0x00,
    'E',0x00, 'V',0x00, 'I',0x00, 'C',0x00, 'E',0x00, ' ',0x00
};

/* USBкַ */
const UINT8  MySerNumInfo[ ] =
{
    /* 0123456789 */
    0x16, 0x03,
    '0',0x00, '1',0x00, '2',0x00, '3',0x00, '4',0x00, '5',0x00,
    '6',0x00, '7',0x00, '8',0x00, '9',0x00,
};

/* USB豸޶ */
const UINT8 MyUSBQUADesc[ ] =
{
    0x0A, 0x06, 0x00, 0x02, 0xFF, 0x00, 0xFF, 0x40, 0x01, 0x00,
};
const UINT8 MyBOSDesc[ ] =
{
    0x05, 0x0f, 0x16, 0x00, 0x02,
    0x07, 0x10, 0x02, 0x02, 0x00, 0x00, 0x00,
    0x0a, 0x10, 0x03, 0x00, 0x0e, 0x00, 0x01, 0x0a, 0xff, 0x07,
};
/* USBȫģʽ,ٶ */
UINT8 TAB_USB_FS_OSC_DESC[ sizeof( MyCfgDescr_HS ) ] =
{
    0x09, 0x07,                                                                 /* ͨ */
};

/* USBģʽ,ٶ */
UINT8 TAB_USB_HS_OSC_DESC[ sizeof( MyCfgDescr_FS ) ] =
{
    0x09, 0x07,                                                                 /* ͨ */
};

/*********************************************************************
 * @fn      USBHS_RCC_Init
 *
 * @brief   Initializes the clock for USB2.0 High speed device.
 *
 * @return  none
 */
void USBHS_RCC_Init( void )
{
    uint32_t regtemp;
    regtemp = RCC->CFGR2;
    /* USBHD PHYʱԴѡⲿHSE */
    regtemp &= ~USBHS_PLL_SRC_MASK;
    regtemp |= USBHS_PLL_SRC_HSE;
    /* USBHD PHYʱӲοԴƵѡѡ2ƵHSE = 8Mhz DIV = 2USBHS_PLL_CKREF_4M = HSE_CLK_8MHz/USBHS_PLL_SRC_PRE_DIV_2 */
    regtemp &= ~USBHS_PLL_SRC_PRE_MASK;
    regtemp |= USBHS_PLL_SRC_PRE_DIV2;
    /* USBHD PHYʱӲοԴƵѡ ѡ4M */
    regtemp &= ~USBHS_PLL_CKREF_MASK;
    regtemp |= USBHS_PLL_CKREF_4M;
    /* USBHD PHY ڲPLLλ1USB PHY ڲ PLL ʹ  */
    regtemp |= USBHS_PLL_ALIVE;
    /* USBOTG FS HD 48M ʱԴ ѡUSBHD PHY */
    regtemp &= ~USB_48M_CLK_SRC_MASK;
    regtemp |= USB_48M_CLK_SRC_PHY;
    /* д */
    RCC->CFGR2 = regtemp;
    /* USBHSʱ */
    RCC->AHBPCENR |= RCC_AHBPeriph_USBHS;
    Delay_Us( 200 );
}

/*********************************************************************
 * @fn      USBHS_Device_Endp_Init
 *
 * @brief   USB2.0豸˵ʼ
 *
 * @return  none
 */
void USBHS_Device_Endp_Init ( void )
{
    /* ʹܶ˵1˵2ͺͽ  */
    USBHSD->ENDP_CONFIG = USBHS_EP0_T_EN | USBHS_EP0_R_EN | USBHS_EP1_T_EN | USBHS_EP2_T_EN | USBHS_EP1_R_EN | USBHS_EP2_R_EN;

    /* ˵ͬ˵ */
    USBHSD->ENDP_TYPE = 0x00;

    /* ˵㻺ģʽ˫ISOBUFģʽҪָ0  */
    USBHSD->BUF_MODE = 0x00;

    /* ˵󳤶Ȱ */
    USBHSD->UEP0_MAX_LEN = 64;
    USBHSD->UEP1_MAX_LEN = 512;
    USBHSD->UEP2_MAX_LEN = 512;
    USBHSD->UEP3_MAX_LEN = 512;
    USBHSD->UEP4_MAX_LEN = 512;
    USBHSD->UEP5_MAX_LEN = 512;
    USBHSD->UEP6_MAX_LEN = 512;
    USBHSD->UEP7_MAX_LEN = 512;
    USBHSD->UEP8_MAX_LEN = 512;
    USBHSD->UEP9_MAX_LEN = 512;
    USBHSD->UEP10_MAX_LEN = 512;
    USBHSD->UEP11_MAX_LEN = 512;
    USBHSD->UEP12_MAX_LEN = 512;
    USBHSD->UEP13_MAX_LEN = 512;
    USBHSD->UEP14_MAX_LEN = 512;
    USBHSD->UEP15_MAX_LEN = 512;

    /* ˵DMAַ */
    USBHSD->UEP0_DMA    = (UINT32)(UINT8 *)EP0_Databuf;
    USBHSD->UEP1_TX_DMA = (UINT32)(UINT8 *)EP1_Tx_Databuf;
    USBHSD->UEP1_RX_DMA = (UINT32)(UINT8 *)EP1_Rx_Databuf;
    USBHSD->UEP2_TX_DMA = (UINT32)(UINT8 *)EP2_Tx_Databuf;
    USBHSD->UEP2_RX_DMA = (UINT32)(UINT8 *)EP2_Rx_Databuf;

    /* ˵ƼĴ */
    USBHSD->UEP0_TX_LEN  = 0;
    USBHSD->UEP0_TX_CTRL = USBHS_EP_T_RES_NAK;
    USBHSD->UEP0_RX_CTRL = USBHS_EP_R_RES_ACK;

    USBHSD->UEP1_TX_LEN  = 512;
    USBHSD->UEP1_TX_CTRL = USBHS_EP_T_AUTOTOG | USBHS_EP_T_RES_ACK;
    USBHSD->UEP1_RX_CTRL = USBHS_EP_R_AUTOTOG | USBHS_EP_R_RES_ACK;

    USBHSD->UEP2_TX_LEN  = 512;
    USBHSD->UEP2_TX_CTRL = USBHS_EP_T_AUTOTOG | USBHS_EP_T_RES_ACK;
    USBHSD->UEP2_RX_CTRL = USBHS_EP_R_AUTOTOG | USBHS_EP_R_RES_ACK;
}

/*********************************************************************
 * @fn      USBHS_Device_Init
 *
 * @brief   USB2.0豸ʼ
 *
 * @return  none
 */
void USBHS_Device_Init ( FunctionalState sta )
{
    if( sta )
    {
        /* DMAٶȡ˵ʹܵ */
        USBHSD->HOST_CTRL = 0x00;
        USBHSD->HOST_CTRL = USBHS_SUSPENDM;

        USBHSD->CONTROL   = 0x00;
        USBHSD->CONTROL   = USBHS_DMA_EN | USBHS_INT_BUSY_EN | USBHS_HIGH_SPEED;
//        USBHSD->CONTROL   = USBHS_DMA_EN | USBHS_INT_BUSY_EN | USBHS_FULL_SPEED;
//        USBHSD->CONTROL   = USBHS_DMA_EN | USBHS_INT_BUSY_EN | USBHS_LOW_SPEED;

        USBHSD->INT_EN    = 0;
        USBHSD->INT_EN    = USBHS_SETUP_ACT_EN | USBHS_TRANSFER_EN | USBHS_DETECT_EN | USBHS_SUSPEND_EN;

        /* ALL endpoint enable */
        USBHSD->ENDP_CONFIG = 0xffffffff;

        /* USB2.0豸˵ʼ */
        USBHS_Device_Endp_Init( );
        Delay_Us(10);

        /* ʹUSB */
        USBHSD->CONTROL |= USBHS_DEV_PU_EN;
    }
    else
    {
        USBHSD->CONTROL &= ~USBHS_DEV_PU_EN;
        USBHSD->CONTROL |= USBHS_ALL_CLR | USBHS_FORCE_RST;
    }
}

/*********************************************************************
 * @fn      USBHS_Device_SetAddress
 *
 * @brief   USB2.0豸豸ַ
 *
 * @return  none
 */
void USBHS_Device_SetAddress( UINT32 address )
{
    USBHSD->DEV_AD = 0;
    USBHSD->DEV_AD = address & 0xff;
}

/*********************************************************************
 * @fn      USBHS_IRQHandler
 *
 * @brief   This function handles USBHS exception.
 *
 * @return  none
 */
void USBHS_IRQHandler( void )
{
    UINT32 end_num;
    UINT32 rx_token;
    UINT16 len = 0x00;
    UINT16 rx_len = 0;
    UINT16 i;
    UINT8  errflag = 0x00;
    UINT8  chtype;

    USBHS_Int_Flag = USBHSD->INT_FG;

    if( USBHS_Int_Flag & USBHS_TRANSFER_FLAG )
    {
        /* ˵㴫䴦 */
        end_num  = (USBHSD->INT_ST) & MASK_UIS_ENDP;
        rx_token = ( ( (USBHSD->INT_ST) & MASK_UIS_TOKEN ) >> 4 ) & 0x03;
        /* 00: OUT, 01:SOF, 10:IN, 11:SETUP */
        if( end_num == 0 )
        {
            /* ˵0 */
            if( rx_token == PID_IN )
            {
                /* ˵0ϴɹж */
                switch( USBHS_Dev_SetupReqCode )
                {
                    case USB_GET_DESCRIPTOR:
                        len = USBHS_Dev_SetupReqLen >= DEF_USBD_UEP0_SIZE ? DEF_USBD_UEP0_SIZE : USBHS_Dev_SetupReqLen;
                        memcpy( EP0_Databuf, pDescr, len );
                        USBHS_Dev_SetupReqLen -= len;
                        pDescr += len;
                        USBHS_Dev_Endp0_Tog ^= 1;
                        USBHSD->UEP0_TX_LEN  = len;
                        USBHSD->UEP0_TX_CTRL =  USBHS_EP_T_RES_ACK | ( USBHS_Dev_Endp0_Tog ? USBHS_EP_T_TOG_0 : USBHS_EP_T_TOG_1 );
                        break;

                    case USB_SET_ADDRESS:
                        USBHS_Device_SetAddress( USBHS_Dev_Address );
                        USBHSD->UEP0_TX_LEN = 0;
                        USBHSD->UEP0_TX_CTRL = 0;
                        USBHSD->UEP0_RX_CTRL = 0;
                        break;

                    default:
                        /* ״̬׶жϻǿϴ0ݰƴ */
                        USBHSD->UEP0_RX_CTRL = USBHS_EP_R_RES_ACK | USBHS_EP_R_TOG_1;
                        pDescr = NULL;
                        break;
                }
            }
            else if( rx_token == PID_OUT )
            {
                USBHSD->UEP0_TX_LEN  = 0;
                USBHSD->UEP0_TX_CTRL = USBHS_EP_T_RES_ACK | USBHS_EP_T_TOG_1;
            }
        }
        else if( end_num == 1 )
        {
            if( rx_token == PID_IN )
            {

            }
            else if( rx_token == PID_OUT )
            {
                rx_len = USBHSD->RX_LEN;
                for( i=0; i<rx_len; i++)
                {
                    EP1_Tx_Databuf[i] = EP1_Rx_Databuf[i];
                }
                USBHSD->UEP1_TX_LEN  = rx_len;
                USBHSD->UEP1_TX_CTRL &= ~USBHS_EP_T_RES_MASK;
                USBHSD->UEP1_TX_CTRL |= USBHS_EP_T_RES_ACK;
                USBHSD->UEP1_RX_CTRL &= ~ USBHS_EP_R_RES_MASK;
                USBHSD->UEP1_RX_CTRL |= USBHS_EP_R_RES_ACK;

            }
        }
        else if( end_num == 2 )
        {
            if( rx_token == PID_IN )
            {

            }
            else if( rx_token == PID_OUT )
            {
                rx_len = USBHSD->RX_LEN;
                for( i=0; i<rx_len; i++)
                {
                    EP2_Tx_Databuf[i] = EP2_Rx_Databuf[i];
                }
                USBHSD->UEP2_TX_LEN  = rx_len;
                USBHSD->UEP2_TX_CTRL &= ~USBHS_EP_T_RES_MASK;
                USBHSD->UEP2_TX_CTRL |= USBHS_EP_T_RES_ACK;
                USBHSD->UEP2_RX_CTRL &= ~ USBHS_EP_R_RES_MASK;
                USBHSD->UEP2_RX_CTRL |= USBHS_EP_R_RES_ACK;
            }
        }
        USBHSD->INT_FG = USBHS_TRANSFER_FLAG;
    }
    else if( USBHS_Int_Flag & USBHS_SETUP_FLAG )
    {
        /* SETUP */
        USBHS_Dev_SetupReqLen = pMySetupReqPak->wLength;
        USBHS_Dev_SetupReqCode = pMySetupReqPak->bRequest;
        chtype = pMySetupReqPak->bRequestType;
        len = 0x00;
        errflag = 0x00;

        /* жϵǰǱ׼ */
        if( ( pMySetupReqPak->bRequestType & USB_REQ_TYP_MASK ) != USB_REQ_TYP_STANDARD )
        {
            /* ,, */
            if( pMySetupReqPak->bRequestType & 0x40 )
            {
                /*  */
                switch( USBHS_Dev_SetupReqCode )
                {
                    default:
                        errflag = 0xFF;                                         /* ʧ */
                        break;
                }
            }
            else if( pMySetupReqPak->bRequestType & 0x20 )
            {
                /*  */
            }

            /* жǷ */
            if( errflag != 0xFF )
            {
                if( USBHS_Dev_SetupReqLen > len )
                {
                    USBHS_Dev_SetupReqLen = len;
                }
                len = ( USBHS_Dev_SetupReqLen >= DEF_USBD_UEP0_SIZE ) ? DEF_USBD_UEP0_SIZE : USBHS_Dev_SetupReqLen;
                memcpy( EP0_Databuf, pDescr, len );
                pDescr += len;
            }
        }
        else
        {
            /* ׼USB */
            switch( USBHS_Dev_SetupReqCode )
            {
                case USB_GET_DESCRIPTOR:
                {
                    switch( ( ( pMySetupReqPak->wValue ) >> 8 ) )
                    {
                        case USB_DESCR_TYP_DEVICE:
                            /* ȡ豸 */
                            pDescr = MyDevDescr;
                            len = MyDevDescr[ 0 ];
                            break;

                        case USB_DESCR_TYP_CONFIG:
                            /* ȡ */
                            pDescr = MyCfgDescr_HS;
                            len = MyCfgDescr_HS[ 2 ] | ( (UINT16)MyCfgDescr_HS[ 3 ] << 8 );
                            break;

                        case USB_DESCR_TYP_STRING:
                            /* ȡַ */
                            switch( ( pMySetupReqPak->wValue ) & 0xff )
                            {
                                case 0:
                                    /* ַ */
                                    pDescr = MyLangDescr;
                                    len = MyLangDescr[ 0 ];
                                    break;

                                case 1:
                                    /* USBַ */
                                    pDescr = MyManuInfo;
                                    len = sizeof( MyManuInfo );
                                    break;

                                case 2:
                                    /* USBƷַ */
                                    pDescr = MyProdInfo;
                                    len = sizeof( MyProdInfo );
                                    break;

                                case 3:
                                    /* USBкַ */
                                    pDescr = MySerNumInfo;
                                    len = sizeof( MySerNumInfo );
                                    break;

                                default:
                                    errflag = 0xFF;
                                    break;
                            }
                            break;

                        case 6:
                            /* 豸޶ */
                            pDescr = ( PUINT8 )&MyUSBQUADesc[ 0 ];
                            len = sizeof( MyUSBQUADesc );
                            break;

                        case 7:
                            /* ٶ */
                            if( USBHS_Dev_Speed == 0x01 )
                            {
                                /* ģʽ */
                                memcpy( &TAB_USB_HS_OSC_DESC[ 2 ], &MyCfgDescr_FS[ 2 ], sizeof( MyCfgDescr_FS ) - 2 );
                                pDescr = ( PUINT8 )&TAB_USB_HS_OSC_DESC[ 0 ];
                                len = sizeof( TAB_USB_HS_OSC_DESC );
                            }
                            else if( USBHS_Dev_Speed == 0x00 )
                            {
                                /* ȫģʽ */
                                memcpy( &TAB_USB_FS_OSC_DESC[ 2 ], &MyCfgDescr_HS[ 2 ], sizeof( MyCfgDescr_HS ) - 2 );
                                pDescr = ( PUINT8 )&TAB_USB_FS_OSC_DESC[ 0 ];
                                len = sizeof( TAB_USB_FS_OSC_DESC );
                            }
                            else
                            {
                                errflag = 0xFF;
                            }
                            break;

                        case 0x0f:
                            /* BOS */
                            /* USB2.0豸֧BOS */
                            errflag = 0xFF;
                            break;
                        default :
                            errflag = 0xFF;
                            break;
                    }

                    /* жǷ */
                    if( errflag != 0xFF )
                    {
                        if( USBHS_Dev_SetupReqLen > len )
                        {
                            USBHS_Dev_SetupReqLen = len;
                        }
                        len = ( USBHS_Dev_SetupReqLen >= DEF_USBD_UEP0_SIZE ) ? DEF_USBD_UEP0_SIZE : USBHS_Dev_SetupReqLen;
                        memcpy( EP0_Databuf, pDescr, len );
                        pDescr += len;
                    }
                }
                break;

                case USB_SET_ADDRESS:
                    /* õַ */
                    USBHS_Dev_Address = ( pMySetupReqPak->wValue )& 0xff;
                    break;

                case USB_GET_CONFIGURATION:
                    /* ȡֵ */
                    EP0_Databuf[ 0 ] = USBHS_Dev_Config;
                    if( USBHS_Dev_SetupReqLen > 1 )
                    {
                        USBHS_Dev_SetupReqLen = 1;
                    }
                    break;

                case USB_SET_CONFIGURATION:
                    /* ֵ */
                    USBHS_Dev_Config = ( pMySetupReqPak->wValue ) & 0xff;
                    USBHS_Dev_EnumStatus = 0x01;
                    break;

                case USB_CLEAR_FEATURE:
                    /*  */
                    if( ( pMySetupReqPak->bRequestType & USB_REQ_RECIP_MASK ) == USB_REQ_RECIP_ENDP )
                    {
                        /* ˵ */
                        switch( ( pMySetupReqPak->wIndex ) & 0xff )/* wIndexL */
                        {
                            case 0x82:
                                /* SET Endp2 Tx to USBHS_EP_T_RES_NAK;USBHS_EP_T_TOG_0;len = 0 */
                                USBHSD->UEP2_TX_LEN = 0;
                                USBHSD->UEP2_TX_CTRL = USBHS_EP_T_RES_NAK | USBHS_EP_T_TOG_0;
                                break;

                            case 0x02:
                                /* SET Endp2 Rx to USBHS_EP_R_RES_ACK;USBHS_EP_R_TOG_0 */
                                USBHSD->UEP2_TX_CTRL = USBHS_EP_R_RES_ACK | USBHS_EP_R_TOG_0;
                                break;

                            case 0x81:
                                /* SET Endp1 Tx to USBHS_EP_T_RES_NAK;USBHS_EP_T_TOG_0;len = 0 */
                                USBHSD->UEP1_TX_LEN = 0;
                                USBHSD->UEP1_TX_CTRL = USBHS_EP_T_RES_NAK | USBHS_EP_T_TOG_0;
                                break;

                            case 0x01:
                                /* SET Endp1 Rx to USBHS_EP_R_RES_NAK;USBHS_EP_R_TOG_0 */
                                USBHSD->UEP1_RX_CTRL = USBHS_EP_R_RES_ACK | USBHS_EP_R_TOG_0;
                                break;

                            default:
                                errflag = 0xFF;
                                break;
                        }
                    }
                    else if( ( pMySetupReqPak->bRequestType & USB_REQ_RECIP_MASK ) == USB_REQ_RECIP_DEVICE )
                    {
                        if( ( ( pMySetupReqPak->wValue ) & 0xff ) == 1 )/* wIndexL */
                        {
                            USBHS_Dev_SleepStatus &= ~0x01;
                        }
                    }
                    else
                    {
                        errflag = 0xFF;
                    }
                    break;

                case USB_SET_FEATURE:
                    /*  */
                    if( ( pMySetupReqPak->bRequestType & 0x1F ) == 0x00 )
                    {
                        /* 豸 */
                        if( pMySetupReqPak->wValue == 0x01 )
                        {
                            if( MyCfgDescr_HS[ 7 ] & 0x20 )
                            {
                                /* ûʹܱ־ */
                                USBHS_Dev_SleepStatus = 0x01;
                            }
                            else
                            {
                                errflag = 0xFF;
                            }
                        }
                        else
                        {
                            errflag = 0xFF;
                        }
                    }
                    else if( ( pMySetupReqPak->bRequestType & 0x1F ) == 0x02 )
                    {
                        /* ö˵ */
                        if( pMySetupReqPak->wValue == 0x00 )
                        {
                            /* ָ˵STALL */
                            switch( ( pMySetupReqPak->wIndex ) & 0xff )
                            {
                                case 0x82:
                                    /* ö˵2 IN STALL */
                                    USBHSD->UEP2_TX_CTRL = ( USBHSD->UEP2_TX_CTRL & ~USBHS_EP_T_RES_MASK ) | USBHS_EP_T_RES_STALL;
                                    break;

                                case 0x02:
                                    /* ö˵2 OUT Stall */
                                    USBHSD->UEP2_RX_CTRL = ( USBHSD->UEP2_RX_CTRL & ~USBHS_EP_R_RES_MASK ) | USBHS_EP_R_RES_STALL;
                                    break;

                                case 0x81:
                                    /* ö˵1 IN STALL */
                                    USBHSD->UEP1_TX_CTRL = ( USBHSD->UEP1_TX_CTRL & ~USBHS_EP_T_RES_MASK ) | USBHS_EP_T_RES_STALL;
                                    break;

                                case 0x01:
                                    /* ö˵1 OUT STALL */
                                    USBHSD->UEP1_RX_CTRL = ( USBHSD->UEP1_RX_CTRL & ~USBHS_EP_R_RES_MASK ) | USBHS_EP_R_RES_STALL;
                                    break;

                                default:
                                    errflag = 0xFF;
                                    break;
                            }
                        }
                        else
                        {
                            errflag = 0xFF;
                        }
                    }
                    else
                    {
                        errflag = 0xFF;
                    }
                    break;

                case USB_GET_INTERFACE:
                    EP0_Databuf[ 0 ] = 0x00;
                    if( USBHS_Dev_SetupReqLen > 1 )
                    {
                        USBHS_Dev_SetupReqLen = 1;
                    }
                    break;

                case USB_SET_INTERFACE:
                    EP0_Databuf[ 0 ] = 0x00;
                    if( USBHS_Dev_SetupReqLen > 1 )
                    {
                        USBHS_Dev_SetupReqLen = 1;
                    }
                    break;

                case USB_GET_STATUS:
                    /* ݵǰ˵ʵ״̬Ӧ */
                    EP0_Databuf[ 0 ] = 0x00;
                    EP0_Databuf[ 1 ] = 0x00;
                    if( pMySetupReqPak->wIndex == 0x81 )
                    {
                        if( ( USBHSD->UEP1_TX_CTRL & USBHS_EP_T_RES_MASK ) == USBHS_EP_T_RES_STALL )
                        {
                            EP0_Databuf[ 0 ] = 0x01;
                        }
                    }
                    else if( pMySetupReqPak->wIndex == 0x01 )
                    {
                        if( ( USBHSD->UEP1_RX_CTRL & USBHS_EP_R_RES_MASK ) == USBHS_EP_R_RES_STALL )
                        {
                            EP0_Databuf[ 0 ] = 0x01;
                        }
                    }
                    else if( pMySetupReqPak->wIndex == 0x82 )
                    {
                        if( ( USBHSD->UEP2_TX_CTRL & USBHS_EP_T_RES_MASK ) == USBHS_EP_T_RES_STALL )
                        {
                            EP0_Databuf[ 0 ] = 0x01;
                        }
                    }
                    else if( pMySetupReqPak->wIndex == 0x02 )
                    {
                        if( ( USBHSD->UEP2_RX_CTRL & USBHS_EP_R_RES_MASK ) == USBHS_EP_R_RES_STALL )
                        {
                            EP0_Databuf[ 0 ] = 0x01;
                        }
                    }
                    if( USBHS_Dev_SetupReqLen > 2 )
                    {
                        USBHS_Dev_SetupReqLen = 2;
                    }
                    break;

                default:
                    errflag = 0xff;
                    break;
            }
        }

        /* ˵0 */
        if( errflag == 0xFF )
        {
            /* IN - STALL / OUT - DATA - STALL */
            USBHS_Dev_SetupReqCode = 0xFF;
            USBHSD->UEP0_TX_LEN  = 0;
            USBHSD->UEP0_TX_CTRL = USBHS_EP_T_RES_STALL;
            USBHSD->UEP0_RX_CTRL = USBHS_EP_R_RES_STALL;
        }
        else
        {
            /* DATA stage (IN -DATA1-ACK) */
            if( chtype & 0x80 )
            {
                len = ( USBHS_Dev_SetupReqLen> DEF_USBD_UEP0_SIZE ) ? DEF_USBD_UEP0_SIZE : USBHS_Dev_SetupReqLen;
                USBHS_Dev_SetupReqLen -= len;
            }
            else
            {
                len = 0;
            }
            USBHSD->UEP0_TX_LEN  = len;
            USBHSD->UEP0_TX_CTRL = USBHS_EP_T_RES_ACK | USBHS_EP_T_TOG_1;
        }
        USBHSD->INT_FG = USBHS_SETUP_FLAG;
    }
    else if( USBHS_Int_Flag & USBHS_DETECT_FLAG )
    {
        /* USB߸λж */
#if 0
        printf("USB ReSet!!!\n");
#endif
        USBHS_Dev_Address = 0x00;
        USBHS_Device_Endp_Init( );                                              /* USB2.0豸˵ʼ */
        USBHS_Device_SetAddress( USBHS_Dev_Address );                           /* USB2.0豸豸ַ */
        USBHSD->INT_FG = USBHS_DETECT_FLAG;
    }
    else if( USBHS_Int_Flag & USBHS_SUSPEND_FLAG )
    {
        /* USB߹/ж */
        /*  */
#if 0
        printf("USB SUSPEND!!!\n");

#endif
        USBHS_Dev_SleepStatus &= ~0x02;
        USBHS_Dev_EnumStatus = 0x01;
        USBHSD->INT_FG = USBHS_SUSPEND_FLAG;
    }
}

