/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2021/06/06
* Description        : Main program body.
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* SPDX-License-Identifier: Apache-2.0
*******************************************************************************/

/*
 *@Note
 USBFSļöٹUļдʾ
 OTG_FS_DM(PA11)OTG_FS_DP(PA12)
 ʾ/C51/CH559HFT.Cļҵļݣ
 ʾ/LIUNEWFILE.TXTļѭдַָ޸ļԣ
 ʾɾ/OLD.TXTļ
 ֧: FAT12/FAT16/FAT32
*/

#include "debug.h"
#include "ch32v30x_usbhs_host.h"
#include "string.h"
#include "CHRV3UFI.h"

__attribute__ ((aligned(4))) UINT8   RxBuffer[ MAX_PACKET_SIZE  ];  // IN, must even address
__attribute__ ((aligned(4))) UINT8   TxBuffer[ MAX_PACKET_SIZE  ];  // OUT, must even address
__attribute__ ((aligned(4))) UINT8   endpTxBuf[ MAX_PACKET_SIZE ];  // OUT, must even address
__attribute__ ((aligned(4))) UINT8   endpRxBuf[ MAX_PACKET_SIZE ];  // OUT, must even addres
__attribute__ ((aligned(4))) UINT8   buf[ 128 ];  // OUT, must even address
__attribute__ ((aligned(4))) UINT8   MY_DATA_BUF[ DISK_BASE_BUF_LEN ];   /* MY_DATA_BUFָⲿRAMĴݻ,Ϊһĳ,ûݻ*/

/* ״̬,ʾ벢ͣ */
void mStopIfError( UINT8 iError )
{
    if ( iError == ERR_SUCCESS )
    {
        return;    /* ɹ */
    }
    printf( "Error:%02x\r\n", iError );  /* ʾ */
    /* ,Ӧ÷ԼCHRV3DiskStatus״̬,CHRV3DiskReadyѯǰUǷ,UѶϿôµȴU̲ٲ,
         Ĵ:
         1һCHRV3DiskReady,ɹ,Open,Read/Write
         2CHRV3DiskReadyɹ,ôǿнͷʼ */
    while(1)
    {  }
}

/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
    UINT8  ret, SecCount, s;
    UINT8  i;
    UINT16 tmp;
    UINT8  tmpbuf[64];
	Delay_Init();
	USART_Printf_Init(115200);
	printf("SystemClk:%d\r\n",SystemCoreClock);
	printf("USBHS HOST Test EXAM 6\r\n");
	pHOST_TX_RAM_Addr = TxBuffer;
	pHOST_RX_RAM_Addr = RxBuffer;
	USBHS_HostInit(ENABLE);
    ret = CHRV3LibInit();
	while(1)
	{
        if( USBHSH->INT_FG & USBHS_DETECT_FLAG )
        {
            USBHSH->INT_FG = USBHS_DETECT_FLAG;
            if( USBHSH->MIS_ST & USBHS_ATTCH )
            {
                ret = USBHS_HostEnum( );
                if( ret == ERR_SUCCESS )
                {
                    printf( "Enum Succeed\r\n" );
                    Delay_Ms(100);
                    // U̲̣USB߸λUӡȡ豸USBַѡĻȡ֮󵽴˴CH103ӳɺ
                    CHRV3DiskStatus = DISK_USB_ADDR;
                    for ( i = 0; i != 10; i ++ )
                    {
                        printf( "Wait DiskReady\r\n" );
                        s = CHRV3DiskReady( );                                 //ȴU׼
                        if ( s == ERR_SUCCESS )
                        {
                            printf("CHRV3DiskStatus:%02x\r\n",CHRV3DiskStatus);
#if DISK_BASE_BUF_LEN
                            //if ( DISK_BASE_BUF_LEN < CHRV3vSectorSize ) {  /* ݻǷ㹻,CHRV3vSectorSizeU̵ʵС */
                            //    printf( "Too large sector size\n" );
                            //    goto UnknownUsbDevice;
                            //  }
#endif
                            /* ѯ */
                            /*      printf( "DiskSize\n" );
                                    i = CHRV3DiskQuery( );
                                    mStopIfError( i );
                                    printf( "TotalSize = %u MB \n", (unsigned int)( mCmdParam.Query.mTotalSector * CHRV3vSectorSizeH / 2 ) );  ʾΪMBΪλ
                            */
                            /* ȡԭļ */
                            printf( "Open\r\n" );
                            strcpy( mCmdParam.Open.mPathName, "/C51/CHRV3HFT.C" );//ļ,ļC51Ŀ¼
                            s = CHRV3FileOpen( );                       //ļ
                            if ( s == ERR_MISS_DIR || s == ERR_MISS_FILE )//ûҵļ
                            {
                                printf( "ûҵļ\r\n" );
                            }
                            else                                        //ҵļ߳
                            {
                                printf( "Query\r\n" );
                                i = CHRV3FileQuery( );                  //ѯǰļϢ
                                mStopIfError( i );
                                printf( "Read\r\n" );
                                CHRV3vFileSize = CHRV3vFileSize+(sizeof( MY_DATA_BUF )-1);    //ԭļĳ
                                SecCount = CHRV3vFileSize/ sizeof( MY_DATA_BUF )  ;//ļ,ΪдΪλ,ȼCHRV3vSectorSize-1Ϊ˶ļβ1Ĳ
                                printf( "Size=%ld, Sec=%d\r\n", CHRV3vFileSize, (UINT16)SecCount );
                                while(SecCount--)
                                {
                                    mCmdParam.Read.mSectorCount = sizeof( MY_DATA_BUF )/512;  //ȡȫ,2ֻȡ2
                                    mCmdParam.Read.mDataBuffer = &MY_DATA_BUF[0];//ָļݻʼַ
                                    i = CHRV3FileRead( );                    //ļȡ
                                    mStopIfError( i );
                                    if(SecCount == 0) break;
                                    /*
                                    for(tmp=0; tmp<sizeof( MY_DATA_BUF ); tmp++)
                                    {
                                    printf("%02X ",(UINT16)MY_DATA_BUF[tmp]);
                                    }
                                    printf("\n");
                                    */
                                }
                                tmp = (CHRV3vFileSize-(sizeof( MY_DATA_BUF )-1))%sizeof( MY_DATA_BUF );
                                if((tmp == 0)&&(CHRV3vFileSize != 0)) tmp = sizeof( MY_DATA_BUF );
                                CHRV3vFileSize = CHRV3vFileSize-(sizeof( MY_DATA_BUF )-1);    //ָԭļĳ
                                /*
                                for(i=0; i<tmp; i++)
                                {
                                  printf("%02X ",(UINT16)MY_DATA_BUF[i]);
                                }
                                printf("\n");
                                */
                                /*
                                                                 ļȽϴ,һζ,ٵCHRV3FileReadȡ,ļָԶƶ
                                 while ( 1 )
                                 {
                                   c = 4;   ÿζȡ4,ԽһζȡԽ
                                   mCmdParam.Read.mSectorCount = c;   ָȡ
                                   mCmdParam.Read.mDataBuffer = &MY_DATA_BUF[0];  ָļݻʼַ
                                   CHRV3FileRead();   ļָԶ 
                                   if ( mCmdParam.Read.mSectorCount < c ) break;   ʵʶС˵ļѾ
                                 }
                                                                   ϣָλÿʼд,ƶļָ
                                  mCmdParam.Locate.mSectorOffset = 3;  ļǰ3ʼд
                                  i = CHRV3FileLocate( );
                                  mCmdParam.Read.mSectorCount = 10;
                                  mCmdParam.Read.mDataBuffer = &MY_DATA_BUF[0];  ָļݻʼַ
                                  CHRV3FileRead();   ֱӶȡļĵ(CHRV3vSectorSizeH*256*3)ֽڿʼ,ǰ3
                                                                   ϣӵԭļβ,ƶļָ
                                  i = CHRV3FileOpen( );
                                  mCmdParam.Locate.mSectorOffset = 0xffffffff;  Ƶļβ,Ϊλ,ԭļ3ֽ,CHRV3vSectorSizeHֽڴʼ
                                  i = CHRV3FileLocate( );
                                  mCmdParam.Write.mSectorCount = 10;
                                  mCmdParam.Write.mDataBuffer = &MY_DATA_BUF[0];
                                  CHRV3FileWrite();   ԭļĺ
                                                                   ʹCHRV3FileReadжݻʼַ
                                  mCmdParam.Read.mSectorCount = 2;
                                  mCmdParam.Read.mDataBuffer = 0x50;  ݷŵ50HʼĻУҪָʼַ
                                  CHRV3FileRead();   ļжȡ2ָ
                                                                    ʹCHRV3FileWriteжݻʼַ
                                  mCmdParam.Wiite.mSectorCount = 2;
                                  mCmdParam.Write.mDataBuffer = 0x50;  50HʼĻед
                                  CHRV3FileWrite();   ָед2ļ
                                */
                                printf( "Close\r\n" );
                                i = CHRV3FileClose( );                            //رļ
                                mStopIfError( i );
                            }
                            printf( "Create\r\n" );
                            strcpy( mCmdParam.Create.mPathName, "/NEWFILE.TXT" );//ļ,ڸĿ¼,ļ
                            s = CHRV3FileCreate( );                               //½ļ,ļѾɾ½ */
                            mStopIfError( s );
                            printf( "Write\r\n" );
                            strcpy( tmpbuf, "0000ABCDEFGHIJKLMNOPQRSTUVWXYZ\xd\xa" );//׼дļ
                            for(i=0; i<(DISK_BASE_BUF_LEN/sizeof(tmpbuf)); i++)
                            {
                                tmp=i*sizeof(tmpbuf);
                                strcpy(&MY_DATA_BUF[tmp],tmpbuf);
                            }
                            for(tmp=0; tmp<sizeof(MY_DATA_BUF); tmp++)
                            {
                                printf("%02X",(UINT16)MY_DATA_BUF[tmp]);
                            }
                            printf("\r\n");
                            for(s=0; s<10; s++)
                            {
                                mCmdParam.Write.mSectorCount = 1;                 //д
                                mCmdParam.Write.mDataBuffer = &MY_DATA_BUF[0];    //ָļݻʼַ
                                i = CHRV3FileWrite( );                            //ļд
                                mStopIfError( i );
                                printf("ɹд %02X\r\n",(UINT16)s);
                            }
                            /* printf( "Modify\n" );
                               mCmdParam.Modify.mFileAttr = 0xff;   : µļ,Ϊ0FFH޸
                               mCmdParam.Modify.mFileTime = 0xffff;   : µļʱ,Ϊ0FFFFH޸,ʹ½ļĬʱ
                               mCmdParam.Modify.mFileDate = MAKE_FILE_DATE( 2015, 5, 18 );  : µļ: 2015.05.18
                               mCmdParam.Modify.mFileSize = 0xffffffff;   : µļ,ֽΪλдļӦɳرļʱԶ³,Դ˴޸
                               i = CHRV3FileModify( );   ޸ĵǰļϢ,޸
                               mStopIfError( i );
                            */
                            printf( "Close\r\n" );
                            mCmdParam.Close.mUpdateLen = 1;                        //Զļ,ֽΪλдļ,óرļԱԶļ
                            i = CHRV3FileClose( );
                            mStopIfError( i );
                            /* ɾĳļ */
                            /*printf( "Erase\n" );
                              strcpy( mCmdParam.Create.mPathName, "/OLD.TXT" );  ɾļ,ڸĿ¼
                              i = CHRV3FileErase( );  ɾļر
                              if ( i != ERR_SUCCESS ) printf( "Error File not exist: %02X\n", (UINT16)i );  ʾ
                            */
                            printf( "Uʾ\r\n" );
                            break;
                        }
                        else
                        {
                            printf("s = %02x\r\n",s);
                            printf("CHRV3DiskStatus:%02x\r\n",CHRV3DiskStatus);
                        }
//                       Delay_Ms( 50 );
                    }
                }
                else
                {

                }
            }
            else
            {
                USBHS_HostInit(DISABLE);
                USBHS_HostInit(ENABLE);
                CHRV3DiskStatus = DISK_DISCONNECT;
                printf("disconnect\r\n");
            }
        }
	}
}




